> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/vm/virtual-machine-instance/modifyinstancetrafficpackage.md).

# ModifyInstanceTrafficPackage

## 1. API Description

This API (ModifyInstanceTrafficPackage) is used to the API is used to modify the data transfer package of a virtual machine instance.

#### Prerequisites

* Query the price of modified data transfer package:call [`DescribeInstanceTrafficPackage`](/api-reference/compute/vm/virtual-machine-instance/inquirypriceinstancetrafficpackage.md) to query the price of specified data transfer package.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">You can only perform this operation on instances whose status is</mark> <mark style="color:blue;">`RUNNING`</mark> <mark style="color:blue;">or</mark> <mark style="color:blue;">`STOPPED`</mark><mark style="color:blue;">.</mark>
* <mark style="color:blue;">If the</mark> [<mark style="color:purple;">`internetChargeType`</mark>](/api-reference/compute/vm/datastructure.md#internetchargetype) <mark style="color:blue;">of your instance is</mark> <mark style="color:blue;">`ByTrafficPackage`</mark><mark style="color:blue;">:</mark>
  * <mark style="color:blue;">For a</mark> <mark style="color:blue;">`PREPAID`</mark> <mark style="color:blue;">instance:</mark>
    * <mark style="color:blue;">Upgrade (target > current) operation will deduct the amount required for this instance purchase. If the balance is insufficient, the request will fail and take effect immediately.</mark>
    * <mark style="color:blue;">Downgrade (target < current) operation will generate an order for the next billing cycle and will take effect by then.</mark>
* <mark style="color:blue;">This API is an async API. Use</mark> <mark style="color:blue;">`DescribeInstanceInternetStatus`</mark> <mark style="color:blue;">to query data transfer status of an instance.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name     | Required | Type   | Description                                                                                                                      |
| ------------------ | -------- | ------ | -------------------------------------------------------------------------------------------------------------------------------- |
| instanceId         | Yes      | String | <p>Instance ID(s).</p><p>To obtain the instance IDs, you can call DescribeInstances and look for instanceId in the response.</p> |
| trafficPackageSize | Yes      | Float  | <p>Size of data transfer package.</p><p>Unit: TB.</p><p>Value range: \[0.0, +)</p>                                               |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| orderNumber    | String | Number of order.                                                                                                      |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Upgrade instance data transfer package.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyInstanceTrafficPackage
<Common Request Params>

Request：
{
  "instanceId": "instanceIdxxx",
  "trafficPackageSize": 100
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {  
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "orderNumber": "xxxx"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
